if (typeof(settings) != "undefined" && settings.platform() == "mac" || navigator.appVersion.indexOf("Mac") != -1) {
    $("#windows-stylesheet").remove()
}
if (typeof(settings) != "undefined") {
    $("body").attr("oncontextmenu", "return false");
}

App = Ember.Application.create();

var attr = Ember.attr;

App.Connection = Ember.Model.extend({
    server: attr(),
    username: attr(),
    remotePath: attr(),
    //region: attr(),
    encryptedPassword: attr(),
    type: attr(),
    linked: attr(),

    serviceEndpoint: function() {
      if (this.get("type") == "s3") {
        return "s3.amazonaws.com";
      }

      if (this.get("type") == "dreamobjects") {
        return "objects.dreamhost.com";
      }

      return "";
    }.property("type"),

    bucket: function(key, value) {
      if (arguments.length > 1) {
        if(value == null) {
            this.set("server", null);
            this.set("remotePath", null);
            return;
        }
        if (this.get("type") == "s3") {
          this.set("server", "https://s3" + value.substring(value.indexOf("-"), value.lastIndexOf("-")) + ".amazonaws.com");  
        }
        
        if (this.get("type") == "dreamobjects") {
          this.set("server", "https://objects.dreamhost.com");  
        }

        this.set("remotePath", value);
      } else{
        return this.get("remotePath");
      }
    }.property(),

    regions: function() {
      if(this.get("type") == "s3" && this.get("isValidated") && this.get("remotePath") == undefined) {
        console.log("Returning regions")
        return [{
            name: "US West (Northen California)",
            value: "us-west-1"
        }, {
            name: "US West (Oregon)",
            value: "us-west-2"
        }, {
            name: "EU (Ireland)",
            value: "eu-west-1"
        }, {
            name: "Asia Pacific (Singapore)",
            value: "ap-southeast-1"
        }, {
            name: "Asia Pacific (Sydney)",
            value: "ap-southeast-2"
        }, {
            name: "Asia Pacific (Tokyo)",
            value: "ap-northeast-1"
        }, {
            name: "South America (Sao Paulo)",
            value: "sa-east-1"
        }, ];
      } else {
        console.log("Returning empty");
        return [];
      }
    }.property("type", "isValidated", "remotePath"),

    protocol: function() {
      if(this.get("type") == "sftp") {
        return "sftp";
      }
      return "s3";
    }.property("type"),

    serverLabel: function() {
        if (this.get("type") == "s3") {
            return "S3 Server";
        }

        return "SSH Server";
    }.property("type"),

    saveButtonLabel: function() {
      if(this.get("linked") == true)  {
        return "Unlink this computer"
      }
      return "Connect";
    }.property("linked"),

    usernameLabel: function() {
        if (this.get("type") == "s3") {
            return "Access Key ID";
        }
        if (this.get("type") == "dreamobjects") {
            return "Access Key";
        }
        return "Username";
    }.property("type"),

    passwordLabel: function() {
        if (this.get("type") == "s3") {
            return "Secret Access Key";
        }
        if (this.get("type") == "dreamobjects") {
            return "Secret Key";
        }
        return "Password";
    }.property("type"),

    passwordPlaceholder: function() {
        if (this.get("type") == "sftp") {
            return "leave blank to use keys";
        }
        return "";
    }.property("type"),

    remotePathLabel: function() {
        if (this.get("type") == "s3") {
            return "Repository";
        }
        return "Remote Path";
    }.property("type"),

    remotePathPlaceholder: function() {
        if (this.get("type") == "s3") {
            return "";
        }
        return "optional"
    }.property("type"),

    validated: function() {
      if(this.get("type") != "sftp") { 
        console.log("authenciated getter");
        u = this.get("username");
        p = this.get("password");

        AWS.config.credentials = new AWS.Credentials(u, p);

        var ep = new AWS.Endpoint(this.get("serviceEndpoint"));
        var s3 = new AWS.S3({endpoint: ep});
        self = this

        s3.listBuckets(function(error, data) {
            if (error) {
              self.set("isValidated", false);
              self.set("s3Buckets", []);
            } else {
                self.set("isValidated", true);
                buckets = arr = jQuery.grep(data.Buckets, function(bucket) {
                    return (bucket.Name.indexOf("strongsync-") != -1);
                });
                self.set("s3Buckets", buckets);
            }
        });

        b = self.get("isValidated");
        console.log(b);
        return b;
      } else {

        return true;
      }

    }.property("username", "password", "type", "isValidated"),

    password: function() {
        pwd = "";


        if (typeof(keychain) != "undefined" && typeof(this.get("server")) != "undefined" && typeof(this.get("username")) != "undefined") {
            pwd = keychain.get(this.get("server"), this.get("username"), this.get("type"), "22", this.get("encryptedPassword"));
        }


        return pwd;
    }.property()

});

App.License = Ember.Model.extend({
    serial: attr()
});


Ember.StrongappAdapter = Ember.Object.extend({

    find: function(record, id) {

        if (typeof(file) != "undefined") {
            jsonString = file.readRepoConfig("~/Strongsync");
        } else
            jsonString = '{"type": "s3"}'

            var data = JSON.parse(jsonString);

        return new Ember.RSVP.Promise(function(resolve, reject) {
            Ember.run.later(this, function() {
                Ember.run(record, record.load, id, data);
                resolve(record);
            }, 0);
        });
    },


    findMany: function(klass, records, ids) {
        var fixtures = klass.FIXTURES,
            requestedData = [];

        for (var i = 0, l = ids.length; i < l; i++) {
            requestedData.push(this._findData(klass, ids[i]));
        }

        return new Ember.RSVP.Promise(function(resolve, reject) {
            Ember.run.later(this, function() {
                Ember.run(records, records.load, klass, requestedData);
                resolve(records);
            }, 0);
        });
    },

    findAll: function(klass, records) {

        p = new Ember.RSVP.Promise(function(resolve, reject) {
            Ember.run.later(this, function() {
                var data = App.Connection.create({
                    type: "sftp",
                    validated: false
                });
                Ember.run(records, records.load, klass, Ember.A([data]));
                resolve(records);
            }, 0);
        });
        return p;
    },

    createRecord: function(record) {
        console.log("create");
        var klass = record.constructor,
            fixtures = klass.FIXTURES;

        return new Ember.RSVP.Promise(function(resolve, reject) {
            Ember.run.later(this, function() {
                //fixtures.push(klass.findFromCacheOrLoad(record.toJSON()));
                record.didCreateRecord();
                resolve(record);
            }, 0);
        });
    },

    saveRecord: function(record) {
        if (typeof(file) != "undefined")
            file.writeRepoConfig(JSON.stringify(record.toJSON(), undefined, 2), "~/Strongsync");

        return new Ember.RSVP.Promise(function(resolve, reject) {
            Ember.run.later(this, function() {
                record.didSaveRecord();

                resolve(record);
            }, 0);
        });
    },

    deleteRecord: function(record) {
        console.log("do delete");
        return new Ember.RSVP.Promise(function(resolve, reject) {
            Ember.run.later(this, function() {
                record.didDeleteRecord();
                resolve(record);
            }, 0);
        });
    }
});

App.Connection.adapter = Ember.StrongappAdapter.create();




App.Router.map(function() {
    this.route("config");
    this.route("license");
});


App.IndexController = Ember.ArrayController.extend({

    tipMessage: null,

    cliMessage: "Up to date",

    paused: false,

    online: true,

    connection: App.Connection.find(1),

    statusMessage: function() {

        if (this.tipMessage)
            return this.tipMessage;

        if (this.paused)
            return "Syncing paused"

        if (!this.online)
            return "Connecting..."

        if (this.cliMessage)
            return this.cliMessage;

        return "";
    }.property('tipMessage', 'cliMessage', 'paused', 'online'),


    reveal: function() {

        //seconds = new Date().getTime() / 1000;

        if (typeof(file) != "undefined")
            file.openPath("~/Strongsync");
        else {
            enterLicense();
        }

    },

    revealItem: function(data) {
        file.revealPath("~/Strongsync" + data);
    },

    preferences: function() {

        if (typeof(preferencesMenu) == "undefined") {
            configureConnection();
        } else {
            preferencesMenu.show();
        }
    },

});




App.ConfigController = Ember.ObjectController.extend({

    connectionTypes: [{
            name: "Amazon S3",
            value: "s3"
        }, {
            name: "DreamHost DreamObjects",
            value: "dreamobjects"
        }, {
            name: "SSH (SFTP)",
            value: "sftp"
        }

    ],

    connectionType: function() {
        m = this.get("model");
        return m.get("type");
    },



    doSave: function(m) {
        if(m.get("linked") != true) {
            controller.transitionToRoute('index');
            if (typeof(keychain) != "undefined" && m.get("password") != null && m.get("password").length > 0) {
                encryptedPassword = keychain.save(m.get("server"), m.get("username"), m.get("password"), this.get("type"), "22");
                m.set("encryptedPassword", encryptedPassword);
            }
            m.set("linked", true);
            s = m.save();

            s.then(function(value) {
                m.set("linked", true);
                strongsync.stopAll();
                setTimeout(function() {
                    strongsync.startAll();
                }, 1000);
            }, function(value) {});
        } else {

            strongsync.stopAll();  
            m.set("username", null);
            m.set("server", null);
            m.set("remotePath", null);
            m.set("password", null);
            m.save()
            m.reload();
            file.unlinkRepo("~/Strongsync");
            m.reload();
            m.set("type", "s3");
            strongsync.startAll();
        }
    },

    save: function() {
        m = this.get("model");
        controller = this;
        self = this;

        if (this.get("type") == "s3" || this.get("type") == "dreamobjects") {

          if (typeof(this.get("remotePath")) != "undefined") {
            m.set("bucket", this.get("remotePath"));
            self.doSave(m);
            return
          }
            var ep = new AWS.Endpoint(this.get("serviceEndpoint"));
            var s3 = new AWS.S3({endpoint: ep});
  

            bucketName = "";
            params = {};

            if(m.get("type") == "s3") {
              region = this.get("region");
              bucketName = "strongsync-" + region + "-" + randomID();         
              params = {
                  "Bucket": bucketName,
                  "CreateBucketConfiguration": {
                      "LocationConstraint": region
                  }
              }
            } 

            if(m.get("type") == "dreamobjects") {
              bucketName = "strongsync-" + randomID();
              params = {
                  "Bucket": bucketName,
                  "CreateBucketConfiguration": {
                      "LocationConstraint": ""
                  }
              }
            }

            this.set("saveButtonLabel", "Creating Bucket...")

            s3.createBucket(params, function(error, data) {
                if (error) {
                  console.log("Error");
                  console.log(error);

                } else {
                   console.log("success");
                   controller.transitionToRoute('index');
                   self.set("saveButtonLabel", "Connect")
                   m.set("bucket", bucketName); 
                   self.doSave(m);
                   m.set("isValidated", true);
                }
            });
        } else {

          self.doSave(m);

      }
        
    },
});

App.ConfigView = Ember.View.extend({
    didInsertElement: function() {
        $("#serverInput").focus();
    }
});

App.LicenseController = Ember.ObjectController.extend({
    save: function() {
        m = this.get("model");

        controller = this;
        $.ajax({
            url: "https://secure.expandrive.com/store/order/license",
            type: "POST",
            data: {
                serial: m.get("serial")
            },
            success: function(data) {
                alert("Thanks for purchasing Strongsync!");
                controller.transitionToRoute('index');
                file.writeLicense(data);
                strongsync.stopAll();
                setTimeout(function() {
                    strongsync.startAll();
                }, 1000);
            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                alert("Invalid serial number");
            }
        });
    },

});

App.LicenseView = Ember.View.extend({
    didInsertElement: function() {
        $("#serialInput").focus();
    }
});

App.HeaderView = Ember.View.extend({

    mouseEnter: function(evt) {
        this.get('controller').set('tipMessage', "Open Strongsync Folder");
    },
    mouseLeave: function(evt) {
        this.get('controller').set('tipMessage', null);
    }

});


App.IndexRoute = Ember.Route.extend({
    model: function() {
        return [];
    }
});


App.ConfigRoute = Ember.Route.extend({
    model: function() {
        return App.Connection.find(1);
    }
});


App.LicenseRoute = Ember.Route.extend({
    model: function() {
        return App.License.create();
    }
});

function randomID() {
    var text = "";
    var possible = "abcdefghijklmnopqrstuvwxyz0123456789";

    for (var i = 0; i < 10; i++)
        text += possible.charAt(Math.floor(Math.random() * possible.length));

    return text;
}

function configureConnection() {
    indexController = window.App.__container__.lookup('controller:index');
    indexController.transitionToRoute('config');
}

function unlinkConnection() {
    indexController = window.App.__container__.lookup('controller:index');
    indexController.transitionToRoute('config');
}

function enterLicense() {
    indexController = window.App.__container__.lookup('controller:index');
    indexController.transitionToRoute('license');
}

function getPassword(repo) {
    model = App.Connection.find(1);
    return model.get("password");
}

function getConfig(repo) {
    configureConnection();
}

function setPaused(value) {
    indexController = window.App.__container__.lookup('controller:index');
    indexController.set("paused", value);
}

function setOnline(value) {
    indexController = window.App.__container__.lookup('controller:index');
    indexController.set("online", value);
}

function addRecentItem(type, name) {
    indexController = window.App.__container__.lookup('controller:index');
    path = name;
    if (indexController.content.length >= 20)
        indexController.content.shiftObject();

    if (name.lastIndexOf("/") != -1)
        name = name.slice(name.lastIndexOf("/") + 1);

    entry = {
        "name": name,
        "type": type,
        "path": path
    };

    if (type == "d") {
        entry["image"] = "images/folder_32x32.png";
    } else {
        entry["image"] = "images/document_32x32.png";
    }

    //    growl.postNotification("Something", name);
    indexController.insertAt(0, entry);
}

function setStatus(value) {
    indexController = window.App.__container__.lookup('controller:index');
    indexController.set("cliMessage", value);
};

function showWindow(value) {
    indexController.set("tipMessage", null);
}
